import * as pulumi from "@pulumi/pulumi";
import * as pulumiAws from "@pulumi/aws";
/**
 * ClusterCreationRoleProvider is a component that wraps creating a role provider that can be passed to the `Cluster`'s `creationRoleProvider`. This can be used to provide a specific role to use for the creation of the EKS cluster different from the role being used to run the Pulumi deployment.
 */
export declare class ClusterCreationRoleProvider extends pulumi.ComponentResource {
    /**
     * Returns true if the given object is an instance of ClusterCreationRoleProvider.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj: any): obj is ClusterCreationRoleProvider;
    readonly role: pulumi.Output<pulumiAws.iam.Role>;
    /**
     * Create a ClusterCreationRoleProvider resource with the given unique name, arguments, and options.
     *
     * @param name The _unique_ name of the resource.
     * @param args The arguments to use to populate this resource's properties.
     * @param opts A bag of options that control this resource's behavior.
     */
    constructor(name: string, args?: ClusterCreationRoleProviderArgs, opts?: pulumi.ComponentResourceOptions);
}
/**
 * The set of arguments for constructing a ClusterCreationRoleProvider resource.
 */
export interface ClusterCreationRoleProviderArgs {
    profile?: pulumi.Input<string>;
    region?: pulumi.Input<string>;
}
